/*
 * This file is generated by jOOQ.
 */
package com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.tables;


import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.DefaultSchema;
import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.Indexes;
import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.Keys;
import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.tables.records.RightSplitRecord;

import java.math.BigDecimal;
import java.sql.Date;
import java.util.Arrays;
import java.util.List;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.Index;
import org.jooq.Name;
import org.jooq.Record;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.11.9"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class RightSplit extends TableImpl<RightSplitRecord> {

    private static final long serialVersionUID = 1554478599;

    /**
     * The reference instance of <code>RIGHT_SPLIT</code>
     */
    public static final RightSplit RIGHT_SPLIT = new RightSplit();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<RightSplitRecord> getRecordType() {
        return RightSplitRecord.class;
    }

    /**
     * The column <code>RIGHT_SPLIT.ID</code>.
     */
    public final TableField<RightSplitRecord, Long> ID = createField("ID", org.jooq.impl.SQLDataType.BIGINT.nullable(false).identity(true), this, "");

    /**
     * The column <code>RIGHT_SPLIT.COUNTRY</code>.
     */
    public final TableField<RightSplitRecord, String> COUNTRY = createField("COUNTRY", org.jooq.impl.SQLDataType.VARCHAR(3).nullable(false), this, "");

    /**
     * The column <code>RIGHT_SPLIT.ID_UTILIZATION_TYPE</code>.
     */
    public final TableField<RightSplitRecord, String> ID_UTILIZATION_TYPE = createField("ID_UTILIZATION_TYPE", org.jooq.impl.SQLDataType.VARCHAR(100).nullable(false), this, "");

    /**
     * The column <code>RIGHT_SPLIT.VALID_FROM</code>.
     */
    public final TableField<RightSplitRecord, Date> VALID_FROM = createField("VALID_FROM", org.jooq.impl.SQLDataType.DATE.nullable(false), this, "");

    /**
     * The column <code>RIGHT_SPLIT.DEM</code>.
     */
    public final TableField<RightSplitRecord, BigDecimal> DEM = createField("DEM", org.jooq.impl.SQLDataType.DECIMAL(40, 20).nullable(false), this, "");

    /**
     * The column <code>RIGHT_SPLIT.DRM</code>.
     */
    public final TableField<RightSplitRecord, BigDecimal> DRM = createField("DRM", org.jooq.impl.SQLDataType.DECIMAL(40, 20).nullable(false), this, "");

    /**
     * Create a <code>RIGHT_SPLIT</code> table reference
     */
    public RightSplit() {
        this(DSL.name("RIGHT_SPLIT"), null);
    }

    /**
     * Create an aliased <code>RIGHT_SPLIT</code> table reference
     */
    public RightSplit(String alias) {
        this(DSL.name(alias), RIGHT_SPLIT);
    }

    /**
     * Create an aliased <code>RIGHT_SPLIT</code> table reference
     */
    public RightSplit(Name alias) {
        this(alias, RIGHT_SPLIT);
    }

    private RightSplit(Name alias, Table<RightSplitRecord> aliased) {
        this(alias, aliased, null);
    }

    private RightSplit(Name alias, Table<RightSplitRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, DSL.comment(""));
    }

    public <O extends Record> RightSplit(Table<O> child, ForeignKey<O, RightSplitRecord> key) {
        super(child, key, RIGHT_SPLIT);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Schema getSchema() {
        return DefaultSchema.DEFAULT_SCHEMA;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<Index> getIndexes() {
        return Arrays.<Index>asList(Indexes.RIGHT_SPLIT_PRIMARY, Indexes.RIGHT_SPLIT_RIGHT_SPLIT_INDEX_01);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Identity<RightSplitRecord, Long> getIdentity() {
        return Keys.IDENTITY_RIGHT_SPLIT;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public UniqueKey<RightSplitRecord> getPrimaryKey() {
        return Keys.KEY_RIGHT_SPLIT_PRIMARY;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<UniqueKey<RightSplitRecord>> getKeys() {
        return Arrays.<UniqueKey<RightSplitRecord>>asList(Keys.KEY_RIGHT_SPLIT_PRIMARY, Keys.KEY_RIGHT_SPLIT_RIGHT_SPLIT_INDEX_01);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public RightSplit as(String alias) {
        return new RightSplit(DSL.name(alias), this);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public RightSplit as(Name alias) {
        return new RightSplit(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public RightSplit rename(String name) {
        return new RightSplit(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public RightSplit rename(Name name) {
        return new RightSplit(name, null);
    }
}
